package java.nio.channels;

import java.net.ServerSocket;
import java.net.SocketOption;
import java.net.SocketAddress;
import java.io.IOException;
import java.nio.channels.spi.SelectorProvider;
import java.nio.channels.spi.AbstractSelectableChannel;

public abstract class ServerSocketChannel extends AbstractSelectableChannel implements NetworkChannel
{
    protected ServerSocketChannel(SelectorProvider provider) {
        super(provider);
    }
    
    public static ServerSocketChannel open() throws IOException {
        return SelectorProvider.provider().openServerSocketChannel();
    }
    
    @Override
    public final int validOps() {
        return 16;
    }
    
    @Override
    public final ServerSocketChannel bind(SocketAddress socketAddress) throws IOException {
        return this.bind(socketAddress, 0);
    }
    
    public abstract ServerSocketChannel bind(SocketAddress p0, int p1) throws IOException;
    
    @Override
    public abstract <T> ServerSocketChannel setOption(SocketOption<T> p0, T p1) throws IOException;
    
    public abstract ServerSocket socket();
    
    public abstract SocketChannel accept() throws IOException;
    
    @Override
    public abstract SocketAddress getLocalAddress() throws IOException;
}
